
  <!DOCTYPE html>
  <html>
    <head>
      <title>Table.tsx</title>
      <link href="https://cdn.jsdelivr.net/npm/semantic-ui@2.4.2/dist/semantic.min.css" type="text/css" rel="stylesheet">
      <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/codemirror.min.js" type="text/javascript" charset="utf-8"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/mode/javascript/javascript.min.js" type="text/javascript" charset="utf-8"></script>
<link href="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/codemirror.min.css" type="text/css" rel="stylesheet">
<script src="../../../../assets/source-file.js" type="text/javascript" charset="utf-8"></script>
<link href="../../../../assets/source-file.css" type="text/css" rel="stylesheet">
    </head>
    <body>
    <div style="margin-top:3em" class="ui container"><h1 class="ui header"><a href="../../../../index.html">TypeScript coverage report</a></h1><table style="margin-top:2em" class="ui celled table"><thead class=""><tr class=""><th class="">Filename</th><th class="">Percent</th><th class="">Threshold</th><th class="">Total</th><th class="">Covered</th><th class="">Uncovered</th></tr></thead><tbody class=""><tr class="positive"><td class="">src/components/Table/Table.tsx</td><td class="">98.18%</td><td class="">80%</td><td class="">220</td><td class="">216</td><td class="">4</td></tr></tbody></table><textarea id="editor" readonly="" style="margin-top:3em">import React, { useEffect, useMemo, useState } from &#x27;react&#x27;;

import s from &#x27;./Table.module.scss&#x27;;
import clsx from &#x27;clsx&#x27;;
import { BaseComponent } from &#x27;../../utils/BaseComponent&#x27;;
import { ReactComponent as CaretDownIcon } from &#x27;./assets/caret-down.svg&#x27;;

export interface TableProps&lt;
  Key extends string = string,
  Row extends { [key in Key]: string | number | boolean } &amp; {
    selected?: boolean;
  } = {
    [key in Key]: string | number | boolean;
  } &amp; { selected?: boolean }
&gt; extends BaseComponent {
  rows: (Row &amp; { selected?: boolean })[];
  columns: {
    name: Key;
    title: React.ReactNode;
  }[];
  scrollTop?: number;
  onClick?: React.MouseEventHandler&lt;HTMLTableElement&gt;;
  onRowClick?: (row: Row) =&gt; void;
  showSorting?: boolean;
}
export const Table: React.FC&lt;TableProps&gt; = ({
  scrollTop,
  className,
  rows,
  columns,
  onClick,
  onRowClick,
  showSorting
}) =&gt; {
  const [headerRef, setHeaderRef] = useState&lt;null | HTMLTableRowElement&gt;(null);
  useEffect(() =&gt; {
    if (headerRef) {
      headerRef.style.transform = `translateY(${scrollTop}px)`;
    }
  }, [headerRef, scrollTop]);

  const [sortKey, setSortKey] = useState&lt;string | null&gt;(null);
  const [sortDirection, setSortDirection] = useState&lt;&#x27;asc&#x27; | &#x27;desc&#x27;&gt;(&#x27;asc&#x27;);
  const sortedRows = useMemo(() =&gt; {
    if (sortKey) {
      return rows.sort((a, b) =&gt; {
        const aValue = a[sortKey];
        const bValue = b[sortKey];
        if (typeof aValue === &#x27;number&#x27; &amp;&amp; typeof bValue === &#x27;number&#x27;) {
          if (sortDirection === &#x27;asc&#x27;) {
            return aValue - bValue;
          } else {
            return bValue - aValue;
          }
        } else if (typeof aValue === &#x27;string&#x27; &amp;&amp; typeof bValue === &#x27;string&#x27;) {
          if (sortDirection === &#x27;asc&#x27;) {
            return aValue.localeCompare(bValue);
          } else {
            return bValue.localeCompare(aValue);
          }
        }
        return 0;
      });
    } else {
      return rows;
    }
  }, [rows, sortDirection, sortKey]);
  return (
    &lt;table onClick={onClick} className={clsx(s.Table, className)}&gt;
      &lt;thead&gt;
        &lt;tr ref={setHeaderRef} className={clsx(s.Table__trHead)}&gt;
          {columns.map((column) =&gt; {
            const props = { columnName: column.name } as any;
            return (
              &lt;th
                className={s.Table__th}
                key={column.name}
                onClick={() =&gt; {
                  if (showSorting) {
                    if (sortKey === column.name) {
                      if (sortDirection === &#x27;asc&#x27;) {
                        setSortDirection(&#x27;desc&#x27;);
                      } else {
                        setSortKey(null);
                      }
                    } else {
                      setSortKey(column.name);
                      setSortDirection(&#x27;asc&#x27;);
                    }
                  }
                }}
                {...props}
              &gt;
                &lt;div className={s.Table__thWrapper} {...props}&gt;
                  {column.title}{&#x27; &#x27;}
                  {sortKey === column.name &amp;&amp; showSorting &amp;&amp; (
                    &lt;div
                      className={clsx(
                        s.Table__thSorting,
                        sortDirection === &#x27;desc&#x27; &amp;&amp; s.Table__thSorting_sort_desc
                      )}
                      {...props}
                    &gt;
                      &lt;CaretDownIcon {...props} /&gt;
                    &lt;/div&gt;
                  )}
                &lt;/div&gt;
              &lt;/th&gt;
            );
          })}
        &lt;/tr&gt;
      &lt;/thead&gt;
      &lt;tbody&gt;
        {sortedRows.map((row, idx) =&gt; (
          &lt;tr
            onClick={() =&gt; {
              if (onRowClick) {
                onRowClick(row);
              }
            }}
            key={idx}
            className={clsx(
              s.tr,
              Boolean(onRowClick) &amp;&amp; s.tr_clickable,
              idx % 2 === 0 &amp;&amp; s.tr_highlighted,
              row.selected &amp;&amp; s.tr_selected
            )}
          &gt;
            {columns.map((column, columnI) =&gt; {
              const props = { columnName: column.name } as any;

              return (
                &lt;td className={s.Table__td} key={columnI} {...props}&gt;
                  {row[column.name]}
                &lt;/td&gt;
              );
            })}
          &lt;/tr&gt;
        ))}
      &lt;/tbody&gt;
    &lt;/table&gt;
  );
};
</textarea><pre id="annotations" style="display:none">[{&quot;file&quot;:&quot;src/components/Table/Table.tsx&quot;,&quot;line&quot;:72,&quot;character&quot;:18,&quot;text&quot;:&quot;props&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/components/Table/Table.tsx&quot;,&quot;line&quot;:72,&quot;character&quot;:26,&quot;text&quot;:&quot;{ columnName: column.name } as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/components/Table/Table.tsx&quot;,&quot;line&quot;:129,&quot;character&quot;:20,&quot;text&quot;:&quot;props&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/components/Table/Table.tsx&quot;,&quot;line&quot;:129,&quot;character&quot;:28,&quot;text&quot;:&quot;{ columnName: column.name } as any&quot;,&quot;kind&quot;:3}]</pre></div>
    <p class="footer-text">TypeScript Coverage Report generated by <a href="https://github.com/plantain-00/type-coverage">type-coverage</a> and <a href="https://github.com/alexcanessa/typescript-coverage-report">typescript-coverage-report</a> at Tue, 05 Oct 2021 23:09:04 GMT</p>
    </body>
  </html>
  